#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <unistd.h>

#define PI 3.141592654

#define  sind(x)        sin(x*(M_PI/180.))
#define  cosd(x)        cos(x*(M_PI/180.))
#define  tand(x)        tan(x*(M_PI/180.))
#define asind(x)        (180./M_PI)*asin(x)
#define acosd(x)        (180./M_PI)*acos(x)
#define atand(x)        (180./M_PI)*atan(x)
#define atan2d(x,y)     (180./M_PI)*atan2((x),(y))

typedef struct {
  double ra, dec;
  float err_maj, err_min;
  int err_ang;
  int extd_flg;
  int mp_flg;
  char isopt;
  char date[11];
  int scan;
  char hemis;
  long id;
  char psfbiJ, psfbiH, psfbiK;
} position;

typedef struct {
  int n_mchs;
  char id;
  float dist;
  int phi;
  float b_m;
  float r_m;
} optical;

typedef struct {
  float m;
  float msig;
  int rd_flg;
  int bl_flg;
  char cc_flg;
  float psfchi;
  float m_stdap;
  float msig_stdap;
  int ndet_flg;
} databand;

typedef struct {
  position pos;
  databand J;
  databand H;
  databand K;
  optical opt;
} enregistrement;

struct noeud{
  enregistrement rec;         
  double r;
  struct noeud *gauche ;
  struct noeud *droit ; 
};

typedef struct {
  int nbBytes;
  int nbFrames;
  long nbData;
  double decN;
  double decS;
  double ram;
  double right;
  double left;
} Strip;

/* Strip s; */

typedef struct {
  int nbBytes;
  long nbElt;
  long dataStart;
  long dataEnd;
  double decN;
  double decS;
  double right;
  double left;
} Frame;

typedef struct {
  double raC;
  double decC;
  double r;
  double alinf, alsup, delinf, delsup;
} Cone;

typedef struct {
  double raC;
  double decC;
  double x;
  double y;
} Box;

/*  VARIABLES GLOBALES  */

#ifndef __2MASS_glob
#define __2MASS_glob
static long mrec = 100, matched, tested, truncated, filtered;
static double maxR;
int DEBUG;
int HTML;
int SORT=0;
#endif

/*  PROTOTYPES  */

void dminmax(double, double *, double *);
double sphDst(double ,double ,double ,double );

int isIn(double , double , double);
int isInGlob(double, double, double, double);
int isFrameOnCone (Frame, Cone);

void testOf(long long *, int, char *, char, long);
int testOf2(long long *, int, char *, char, long);

enregistrement read2MASS(FILE *);
enregistrement read2MASSn(char *);
void printEnr(enregistrement, FILE *);

void posCode(position, unsigned char *, long);
void magCode(databand, unsigned char *, char, long);
void optCode(optical, unsigned char *, long);

void posDecode(unsigned char *, position *);
void magDecode(unsigned char *, databand *);
void optDecode(unsigned char *, optical *);

struct noeud *ajoutarbre(struct noeud *, enregistrement, double);
void affarbre(struct noeud *);
struct noeud *allouernoeud();
double maxArbre(struct noeud *);

void nrerror(char *);
int *ivector(long , long );
long *lvector(long , long );
unsigned long *ulvector(long , long );
double *dvector(long , long );
position *posvector(long , long );
enregistrement *enrvector(long , long);
void free_ivector(int *, long , long);
void free_lvector(long *, long , long );
void free_ulvector(unsigned long *, long , long );
void free_dvector(double *, long , long );
void free_posvector(position *, long , long );
void free_enrvector(enregistrement *, long , long );


void indexxPtr(unsigned long , double [], unsigned long []);
